﻿Imports System.Drawing.Drawing2D

Public Class Form1
    ' The polygon's points.
    Private Points() As Point = _
    { _
        New Point(133, 14), _
        New Point(44, 228), _
        New Point(255, 83), _
        New Point(16, 74), _
        New Point(214, 246) _
    }

    ' Draw the polygon.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.SmoothingMode = SmoothingMode.AntiAlias
        e.Graphics.FillPolygon(Brushes.Yellow, Points)
        e.Graphics.DrawPolygon(Pens.Red, Points)
    End Sub

    ' Set the cursor depending on whether the mouse is over the polygon.
    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        Dim new_cursor As Cursor
        If (PointIsInPolygon(Points, e.Location)) Then
            new_cursor = Cursors.Cross
        Else
            new_cursor = Cursors.Default
        End If

        ' Update the cursor.
        If (Me.Cursor <> new_cursor) Then Me.Cursor = new_cursor
    End Sub

    ' Return true if the point is inside the polygon.
    Private Function PointIsInPolygon(ByVal polygon() As Point, ByVal target_point As Point) As Boolean
        ' Make a GraphicsPath containing the polygon.
        Dim path As New GraphicsPath()
        path.AddPolygon(polygon)

        ' See if the point is inside the path.
        Return path.IsVisible(target_point)
    End Function
End Class
